module "argocd" {
  source = "../../../common/argocd"

  enable_gzip                                = var.enable_gzip
  do_token                                   = var.do_token
  do_region                                  = var.do_region
  do_spaces_access_id                        = var.do_spaces_access_id
  do_spaces_secret_key                       = var.do_spaces_secret_key
  allow_local_s3                             = false
  kubeconfig_path                            = var.kubeconfig_path
  gitlab_username                            = var.gitlab_username
  gitlab_password                            = var.gitlab_password
  gitlab_runner_token                        = var.gitlab_runner_token
  gitlab_runner_s3_bucket                    = var.gitlab_runner_s3_bucket
  gitlab_runner_do_token                     = var.gitlab_runner_do_token
  services_deployment_revision               = var.services_deployment_revision
  argocd_keyfile                             = var.argocd_keyfile
  main_domain                                = var.main_domain
  dev_domain                                 = var.dev_domain
  loki_bucket_name                           = var.loki_bucket_name
  mimir_bucket_name                          = var.mimir_bucket_name
  tempo_bucket_name                          = var.tempo_bucket_name
  loki_replicas                              = var.loki_replicas
  argocd_webhook_secret                      = var.argocd_webhook_secret
  argocd_discord_webhook_url                 = var.argocd_discord_webhook_url
  github_runner_token                        = var.github_runner_token
  github_runner_webhook_token                = var.github_runner_webhook_token
  github_workflow_access_tokens              = var.github_workflow_access_tokens
  feeds_s3_access_key_id                     = var.feeds_s3_access_key_id
  feeds_s3_secret_access_key                 = var.feeds_s3_secret_access_key
  gitlab_runner_s3_access_key                = var.gitlab_runner_s3_access_key
  gitlab_runner_s3_secret_key                = var.gitlab_runner_s3_secret_key
  gitlab_ci_pipelines_exporter_token         = var.gitlab_ci_pipelines_exporter_token
  gitlab_ci_pipelines_exporter_webhook_token = var.gitlab_ci_pipelines_exporter_webhook_token
  grafana_admin_username                     = var.grafana_admin_username
  grafana_admin_password                     = var.grafana_admin_password
  cluster_digitalocean_token                 = var.cluster_digitalocean_token
  feeds_s3_bucket                            = var.feeds_s3_bucket
  ghcr_io_registry_config                    = var.ghcr_io_registry_config
  use_production_tls                         = var.use_production_tls
  enable_linkerd_cni                         = true
  linkerd_replicas                           = 2
  prometheus_replicas                        = 2
  enable_additional_scrape_configs           = true
  enable_observability_stack                 = var.enable_observability_stack
  observability_repository_revision          = var.observability_repository_revision
  main_cluster_config                        = jsonencode(yamldecode(file(var.kubeconfig_path)))

  ugc_cluster_api_server             = var.ugc_cluster_api_server
  ugc_cluster_bearer_token           = var.ugc_cluster_bearer_token
  ugc_cluster_ca_certificate         = var.ugc_cluster_ca_certificate
  ugc_cluster_digitalocean_token     = var.ugc_cluster_digitalocean_token
  ugc_domain                         = var.ugc_domain
  ugc_discourse_pg_host              = var.ugc_discourse_pg_host
  ugc_discourse_pg_port              = var.ugc_discourse_pg_port
  ugc_discourse_pg_database          = var.ugc_discourse_pg_database
  ugc_discourse_pg_username          = var.ugc_discourse_pg_username
  ugc_discourse_pg_password          = var.ugc_discourse_pg_password
  ugc_discourse_admin_username       = var.ugc_discourse_admin_username
  ugc_discourse_admin_email          = var.ugc_discourse_admin_email
  ugc_discourse_admin_password       = var.ugc_discourse_admin_password
  ugc_smtp_host                      = var.ugc_smtp_host
  ugc_smtp_port                      = var.ugc_smtp_port
  ugc_smtp_username                  = var.ugc_smtp_username
  ugc_smtp_password                  = var.ugc_smtp_password
  ugc_discourse_install              = var.ugc_discourse_install
  ugc_discourse_s3_region            = var.ugc_discourse_s3_region
  ugc_discourse_s3_endpoint          = var.ugc_discourse_s3_endpoint
  ugc_discourse_s3_access_key_id     = var.ugc_discourse_s3_access_key_id
  ugc_discourse_s3_secret_access_key = var.ugc_discourse_s3_secret_access_key
  ugc_discourse_s3_cdn_url           = var.ugc_discourse_s3_cdn_url
  ugc_discourse_s3_upload_bucket     = var.ugc_discourse_s3_upload_bucket
  ugc_discourse_s3_backup_bucket     = var.ugc_discourse_s3_backup_bucket
  ugc_cloudflare_dns_api_token       = var.ugc_cloudflare_dns_api_token
  ugc_linkerd_replicas               = var.ugc_linkerd_replicas

  rustypaste_token = var.rustypaste_token

  providers = {
    kubernetes     = kubernetes
    kubernetes.ugc = kubernetes.ugc
    kubectl        = kubectl
    kustomization  = kustomization
  }
}
